<template>
  <app-drawer
    v-model="isVisible"
    custom-class="integration-salesforce-drawer"
    title="Salesforce"
    pre-title="Integration"
    has-border
    @close="cancel"
  >
    <template #beforeTitle>
      <img
        class="w-6 h-6 mr-2"
        :src="logoUrl"
        alt="Salesforce logo"
      />
    </template>
    <template #content>
      <el-form
        class="form integration-hackerNews-form"
        @submit.prevent
      >
        <div class="flex flex-col gap-1 items-start">
          <span class="text-sm font-medium">GetSphere package</span>
          <span
            class="text-2xs font-light mb-2 text-gray-600"
          >
            To connect the Salesforce integration, install
            the package with the connected app to access
            your Salesforce organization. <br />
          </span>
          <el-button @click="handlePackageInstall">
            Install Package
          </el-button>
        </div>
      </el-form>
    </template>
    <template #footer>
      <div>
        <el-button
          class="btn btn--md btn--bordered mr-4"
          :disabled="loading"
          @click="cancel"
        >
          <app-i18n code="common.cancel" />
        </el-button>
        <el-button
          id="devConnect"
          class="btn btn--md btn--primary"
          :disabled="connectDisabled || loading"
          :loading="loading"
          @click="save"
        >
          <app-i18n code="common.connect" />
        </el-button>
      </div>
    </template>
  </app-drawer>
</template>

<script setup>
import config from '@/config';
import Nango from '@nangohq/frontend';
import { computed, defineProps, defineEmits } from 'vue';
import AuthCurrentTenant from '@/modules/auth/auth-current-tenant';
import { useThrottleFn } from '@vueuse/core';
import { useStore } from 'vuex';
import { CrowdIntegrations } from '@/integrations/integrations-config';

const props = defineProps({
  integration: {
    type: Object,
    default: null,
  },
  modelValue: {
    type: Boolean,
    default: false,
  },
});

const store = useStore();

const emit = defineEmits(['update:modelValue']);
const isVisible = computed({
  get() {
    return props.modelValue;
  },
  set(value) {
    return emit('update:modelValue', value);
  },
});

const logoUrl = CrowdIntegrations.getConfig('salesforce').image;

const cancel = () => {
  isVisible.value = false;
}

const tenantId = computed(() => AuthCurrentTenant.get());

const callOnboard = useThrottleFn(async () => {
  await store.dispatch('integration/doSalesforceConnect');
}, 2000);

const save = async () => {
  const nango = new Nango({ host: config.nangoUrl, publicKey: config.nangoPublicKey });
  await nango.auth(
    'salesforce',
    `${tenantId.value}-salesforce`,
  );
  await callOnboard();
  isVisible.value = false;
};
const handlePackageInstall = () => {
  window.open(config.salesforcePackageLink, '__blank');
};
</script>

<script>
export default {
  name: 'AppSalesforceConnectDrawer',
};
</script>

<style lang="scss">
.integration-salesforce-drawer {
  .el-form-item__content {
    margin: 0;
  }
}
</style>
